///////////////////////////////
#include <acknex.h>
#include <default.c>
///////////////////////////////

var amb = 0;
var lgt = 0;
var alph = 100;
var ambl = 255;
var amre = 255;
var amgr = 255;
var dibl = 255;
var dire = 255;
var digr = 255;
var spbl = 255; 
var spre = 255;
var spgr = 255;
var rl = 255;
var gl = 255;
var bl = 255;
var zm = 50;

ENTITY* guard;
BMAP* bg = "but.bmp";
BMAP* cursor = "cursor.bmp";
STRING* title = "Entity Light Viewer";
MATERIAL* mtl_smaragd =
{  
ambient_blue = 0;  
ambient_green = 0;  
ambient_red = 0;  
diffuse_blue = 0;  
diffuse_green = 0; 
diffuse_red = 0;  
specular_blue = 0;  
specular_green = 0;  
specular_red = 0;  
power = 10;
}

TEXT* Explain = { 
   pos_x = 620; pos_y = 60;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Ambience"); 
}


TEXT* Explain2 = { 
   pos_x = 620; pos_y = 85;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Light"); 
}


TEXT* Explain3 = { 
   pos_x = 620; pos_y = 110;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Ghost"); 
}

TEXT* Explain4 = { 
   pos_x = 605; pos_y = 135;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Ambient Blue"); 
}


TEXT* Explain5 = { 
   pos_x = 605; pos_y = 160;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Ambient Green"); 
}


TEXT* Explain6 = { 
   pos_x = 605; pos_y = 185;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Ambient Red"); 
}


TEXT* Explain7 = { 
   pos_x = 605; pos_y = 210;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Diffuse Blue"); 
}


TEXT* Explain8 = { 
   pos_x = 605; pos_y = 235;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Diffuse Green"); 
}

TEXT* Explain9 = { 
   pos_x = 605; pos_y = 260;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Diffuse Red"); 
}


TEXT* Explain10 = { 
   pos_x = 605; pos_y = 285;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Specular Blue"); 
}


TEXT* Explain11 = { 
   pos_x = 605; pos_y = 310;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Specular Green"); 
}

TEXT* Explain12 = { 
   pos_x = 605; pos_y = 335;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Specular Red"); 
}

TEXT* Explain13 = { 
   pos_x = 605; pos_y = 360;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Blue Light"); 
}


TEXT* Explain14 = { 
   pos_x = 605; pos_y = 385;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Green Light"); 
}

TEXT* Explain15 = { 
   pos_x = 605; pos_y = 410;
	layer=16;
   font = "Croobie#20bi";
   flags = SHADOW | SHOW;
   string("Red Light"); 
}

PANEL* bgpan =
{
    pos_x = 000;
    pos_y = 000;
    layer = 1;
    bmap = bg;
    flags = OVERLAY | SHOW;
}
PANEL* ambpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 60;
    hslider (0, 0, 100, "slider3.bmp", 0, 200, amb);
    flags = OVERLAY | SHOW;

}

PANEL* amblpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 135;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, ambl);
    flags = OVERLAY | SHOW;
    

}

PANEL* amgrpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 160;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, amgr);
    flags = OVERLAY | SHOW;

}

PANEL* amrepan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 185;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, amre);
    flags = OVERLAY | SHOW;

}

PANEL* direpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 260;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, dire);
    flags = OVERLAY | SHOW;

}

PANEL* diblpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 210;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, dibl);
    flags = OVERLAY | SHOW;

}

PANEL* digrpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 235;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, digr);
    flags = OVERLAY | SHOW;

}


PANEL* sublpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 285;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, spbl);
    flags = OVERLAY | SHOW;

}


PANEL* sugrpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 310;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, spgr);
    flags = OVERLAY | SHOW;

}

PANEL* surepan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 335;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, spre);
    flags = OVERLAY | SHOW;

}

PANEL* rlpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 410;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, rl);
    flags = OVERLAY | SHOW;

}

PANEL* glpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 385;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, gl);
    flags = OVERLAY | SHOW;

}

PANEL* blpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 360;
    hslider (0, 0, 100, "slider3.bmp", 0, 255, bl);
    flags = OVERLAY | SHOW;

}

PANEL* alphpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 110;
    hslider (0, 0, 100, "slider3.bmp", 0, 100, alph);
    flags = OVERLAY | SHOW; 
}

PANEL* lgtpan =
{
    bmap = "slider2.bmp";
    layer = 2;
    pos_x = 500;
    pos_y = 85;
    hslider (0, 0, 100, "slider3.bmp", 0, 1000, lgt);
    flags = OVERLAY | SHOW;

}


PANEL* zoompan =
{
    bmap = "slider2h.bmp";
    layer = 2;
    pos_x = 375;
    pos_y = 350;
    vslider (0, 0, 100, "slider3h.bmp", 50, 500, zm);
    flags = OVERLAY | SHOW;

}
var run_percentage;
action stand()
{
		guard = me;
		while (1)
		{
		ent_animate(my,"idle",run_percentage, ANM_CYCLE);
		run_percentage += 1 * time_step;	
		wait(1);
		
		}
}
	var cam_height;
	var cam_angle = 180;
	var zoom;
	

	VECTOR temp;
	
function main()
{
	video_window(vector(0,0,0),vector(0,0,0),112,title);
	shadow_stencil = 2;
	level_load("small.hmp");
	ENTITY* sky = ent_createlayer("skycube+6.dds", SKY | CUBE | SHOW, 0);
	mouse_map = NULL;
 	mouse_mode = 4;
 	video_mode = 8;
	sky_color.blue = 0;
	guard = ent_create ("armor knight.mdl", vector(0, 90, 20), stand);
	set (guard, SHADOW);
 	guard.material = mtl_smaragd;
 	 
	camera.size_x=screen_size.x/1.6;
	camera.size_y=screen_size.y;	
	while(1)
	{
	if (alph==100)
	{
	reset(guard,TRANSLUCENT);		
	}
	else
	{
	set (guard, TRANSLUCENT);  	
	}
	
	mtl_smaragd.ambient_blue = ambl; 
	mtl_smaragd.ambient_green = amgr; 
	mtl_smaragd.ambient_red = amre; 
	mtl_smaragd.diffuse_red = dire; 
	mtl_smaragd.diffuse_green = digr; 
	mtl_smaragd.diffuse_blue = dibl; 
	mtl_smaragd.specular_red = spre; 
	mtl_smaragd.specular_green = spgr; 
	mtl_smaragd.specular_blue = spbl;
	guard.red = rl;
	guard.blue = bl;
	guard.green = gl;
	zoom=zm;
	guard.ambient = amb;
	guard.lightrange = lgt;
	guard.alpha = alph;
	
	if(mouse_left)
	{
	if(mouse_pos.x<screen_size.x/1.6)
	{
	cam_height += 10 * (3*-mouse_force.y) * time_step;
	cam_angle += 10 * (3*-mouse_force.x) * time_step;
	}
	}
		cam_height = clamp(cam_height, -50, 300);
		
		camera.x = guard.x - zoom * cos(cam_angle);
		camera.y = guard.y - zoom * sin(cam_angle);
		camera.z = guard.z + cam_height;
		
		vec_set(temp.x, guard.x);
		vec_sub(temp.x, camera.x);
		vec_to_angle(camera.pan, temp);
		wait(1);
		
	}
}